## vulkan-utility-libraries 1.3.275.0

=== CMakeLists.txt ===
# Copyright 2023 The Khronos Group Inc.
# Copyright 2023 Valve Corporation
# Copyright 2023 LunarG, Inc.
#
# SPDX-License-Identifier: Apache-2.0
cmake_minimum_required(VERSION 3.17.2)

project(VUL LANGUAGES CXX)

string(COMPARE EQUAL ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_SOURCE_DIR} VUL_IS_TOP_LEVEL) # Remove when min is 3.21

set_property(GLOBAL PROPERTY USE_FOLDERS ON) # Remove when min is 3.26, see CMP0143

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_C_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN "YES")

# This variable enables downstream users to customize the target API
# variant (e.g. Vulkan SC)
set(API_TYPE "vulkan")

add_subdirectory(scripts)

find_package(VulkanHeaders CONFIG)

add_subdirectory(src)
add_subdirectory(include)

if (VUL_IS_TOP_LEVEL)
    option(BUILD_TESTS "Build tests")
    if (BUILD_TESTS)
        enable_testing()
        add_subdirectory(tests)
    endif()

    include(GNUInstallDirs)
    include(CMakePackageConfigHelpers)

    install(
        DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include/${API_TYPE}/"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/vulkan"
    )

    # Create VulkanUtilityLibraries-targets.cmake
    set_target_properties(VulkanLayerSettings PROPERTIES EXPORT_NAME "LayerSettings")
    set_target_properties(VulkanUtilityHeaders PROPERTIES EXPORT_NAME "UtilityHeaders")
    set_target_properties(VulkanCompilerConfiguration PROPERTIES EXPORT_NAME "CompilerConfiguration")
    install(
        TARGETS VulkanLayerSettings VulkanUtilityHeaders VulkanCompilerConfiguration
        EXPORT VulkanUtilityLibraries-targets
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    )
    install(
        EXPORT VulkanUtilityLibraries-targets
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VulkanUtilityLibraries
        NAMESPACE Vulkan::
    )

    # Create VulkanUtilityLibrariesConfig.cmake
    set(VUL_EXPORT_TARGETS ${CMAKE_INSTALL_LIBDIR}/cmake/VulkanUtilityLibraries/VulkanUtilityLibraries-targets.cmake)
    file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/VulkanUtilityLibrariesConfig.cmake.in" [=[
        include(CMakeFindDependencyMacro)
        # NOTE: Because VulkanHeaders is a PUBLIC dependency it needs to be found prior to VulkanUtilityLibraries
        find_dependency(VulkanHeaders REQUIRED)

        @PACKAGE_INIT@

        include(@PACKAGE_VUL_EXPORT_TARGETS@)
    ]=])

    configure_package_config_file(
        ${CMAKE_CURRENT_BINARY_DIR}/VulkanUtilityLibrariesConfig.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/VulkanUtilityLibrariesConfig.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VulkanUtilityLibraries
        PATH_VARS VUL_EXPORT_TARGETS
        NO_SET_AND_CHECK_MACRO
        NO_CHECK_REQUIRED_COMPONENTS_MACRO
    )

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/VulkanUtilityLibrariesConfig.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VulkanUtilityLibraries
    )
endif()

=== include/CMakeLists.txt ===
# Copyright 2023 The Khronos Group Inc.
# Copyright 2023 Valve Corporation
# Copyright 2023 LunarG, Inc.
#
# SPDX-License-Identifier: Apache-2.0
target_include_directories(VulkanLayerSettings PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

target_sources(VulkanLayerSettings PRIVATE
	vulkan/layer/vk_layer_settings.h
	vulkan/layer/vk_layer_settings.hpp
)

set(CMAKE_FOLDER "${CMAKE_FOLDER}/VulkanUtilityHeaders")

add_library(VulkanUtilityHeaders INTERFACE)
add_library(Vulkan::UtilityHeaders ALIAS VulkanUtilityHeaders)

# https://cmake.org/cmake/help/latest/release/3.19.html#other
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.19")
	target_sources(VulkanUtilityHeaders PRIVATE
		vulkan/utility/vk_dispatch_table.h
		vulkan/vk_enum_string_helper.h
		vulkan/utility/vk_format_utils.h
		vulkan/utility/vk_struct_helper.hpp
	)
endif()

target_link_Libraries(VulkanUtilityHeaders INTERFACE Vulkan::Headers)

target_include_directories(VulkanUtilityHeaders INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>)

=== src/CMakeLists.txt ===
# Copyright 2023 The Khronos Group Inc.
# Copyright 2023 Valve Corporation
# Copyright 2023 LunarG, Inc.
#
# SPDX-License-Identifier: Apache-2.0

add_library(VulkanCompilerConfiguration INTERFACE)
add_library(Vulkan::CompilerConfiguration ALIAS VulkanCompilerConfiguration)
if(${CMAKE_CXX_COMPILER_ID} MATCHES "(GNU|Clang)")
    target_compile_options(VulkanCompilerConfiguration INTERFACE
        -Wpedantic
        -Wunreachable-code
        -Wunused-function
        -Wall
        -Wextra
        -Wpointer-arith
        -Wextra-semi
    )
    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
        target_compile_options(VulkanCompilerConfiguration INTERFACE
            -Wunreachable-code-return
            -Wconversion
            -Wimplicit-fallthrough
            -Wstring-conversion
        )
    endif()
elseif(MSVC)
    target_compile_options(VulkanCompilerConfiguration INTERFACE
        /W4
        /we5038 # Enable warning about MIL ordering in constructors
    )

    # Enforce stricter ISO C++
    target_compile_options(VulkanCompilerConfiguration INTERFACE /permissive-)

    # Speed up Visual Studio builds
    if (MSVC_IDE)
        target_compile_options(VulkanCompilerConfiguration INTERFACE /MP)
    endif()
endif()

target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_ENABLE_BETA_EXTENSIONS)
if(WIN32)
    # Minimize what Windows.h leaks
    target_compile_definitions(VulkanCompilerConfiguration INTERFACE NOMINMAX WIN32_LEAN_AND_MEAN)

    target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_USE_PLATFORM_WIN32_KHR)
elseif(ANDROID)
    target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_USE_PLATFORM_ANDROID_KHR)
elseif(APPLE)
    target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_USE_PLATFORM_METAL_EXT)
    if (IOS)
        target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_USE_PLATFORM_IOS_MVK)
    else()
        target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_USE_PLATFORM_MACOS_MVK)
    endif()
else()
    message(DEBUG "Figure out how to gracefully handle Linux|BSD WSI...")
    
    #option(BUILD_WSI_XCB_SUPPORT "Build XCB WSI support" ON)
    #option(BUILD_WSI_XLIB_SUPPORT "Build Xlib WSI support" ON)
    #option(BUILD_WSI_WAYLAND_SUPPORT "Build Wayland WSI support" ON)

    #find_package(PkgConfig REQUIRED QUIET) # Use PkgConfig to find Linux system libraries

    #if(BUILD_WSI_XCB_SUPPORT)
    #    pkg_check_modules(XCB REQUIRED QUIET IMPORTED_TARGET xcb)
    #    target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_USE_PLATFORM_XCB_KHR)
    #endif()

    #if(BUILD_WSI_XLIB_SUPPORT)
    #    pkg_check_modules(X11 REQUIRED QUIET IMPORTED_TARGET x11)
    #    target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_USE_PLATFORM_XLIB_KHR VK_USE_PLATFORM_XLIB_XRANDR_EXT)
    #endif()

    #if(BUILD_WSI_WAYLAND_SUPPORT)
    #    pkg_check_modules(WAYlAND_CLIENT QUIET REQUIRED IMPORTED_TARGET wayland-client)
    #    target_compile_definitions(VulkanCompilerConfiguration INTERFACE VK_USE_PLATFORM_WAYLAND_KHR)
    #endif()
endif()

option(VUL_WERROR "Treat compiler warnings as errors")
if (VUL_WERROR)
    if (MSVC)
        target_compile_options(VulkanCompilerConfiguration INTERFACE /WX)
        target_link_options(VulkanCompilerConfiguration INTERFACE /WX)
    else()
        target_compile_options(VulkanCompilerConfiguration INTERFACE -Werror)
        # TODO: Figure out linker warnings as errors for non-WIN32
    endif()
endif()

add_subdirectory(layer)

=== tests/CMakeLists.txt ===
# Copyright 2023 The Khronos Group Inc.
# Copyright 2023 Valve Corporation
# Copyright 2023 LunarG, Inc.
#
# SPDX-License-Identifier: Apache-2.0

find_package(GTest REQUIRED CONFIG)
find_package(magic_enum REQUIRED CONFIG)

include(GoogleTest)

add_executable(vul_tests)

target_include_directories(vul_tests PRIVATE
    ${VUL_SOURCE_DIR}/src/layer
)

target_sources(vul_tests PRIVATE
    struct_helper.cpp
    test_formats.cpp
    test_interface.cpp
    test_setting_api.cpp
    test_setting_cast.cpp
    test_setting_cpp.cpp
    test_setting_env.cpp
    test_setting_file.cpp
    test_setting_util.cpp
    vk_enum_string_helper.cpp
)

target_link_libraries(vul_tests PRIVATE
    GTest::gtest
    GTest::gtest_main
    magic_enum::magic_enum
    Vulkan::UtilityHeaders
    Vulkan::LayerSettings
    Vulkan::CompilerConfiguration
)

# Test add_subdirectory suppport
add_test(NAME integration.add_subdirectory
    COMMAND ${CMAKE_CTEST_COMMAND}
        --build-and-test ${CMAKE_CURRENT_LIST_DIR}/integration
                         ${CMAKE_CURRENT_BINARY_DIR}/add_subdirectory
        --build-generator ${CMAKE_GENERATOR}
        --build-options -DFIND_PACKAGE_TESTING=OFF -DCMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}
)

set(test_install_dir "${CMAKE_CURRENT_BINARY_DIR}/install")
add_test(NAME integration.install
    COMMAND ${CMAKE_COMMAND} --install ${PROJECT_BINARY_DIR} --prefix ${test_install_dir} --config $<CONFIG>
)

# Test find_package suppport
add_test(NAME integration.find_package
    COMMAND ${CMAKE_CTEST_COMMAND}
        --build-and-test ${CMAKE_CURRENT_LIST_DIR}/integration
                         ${CMAKE_CURRENT_BINARY_DIR}/find_package
        --build-generator ${CMAKE_GENERATOR}
        --build-options -DFIND_PACKAGE_TESTING=ON "-DCMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH};${test_install_dir}"
)

# Installing comes before testing
set_tests_properties(integration.find_package PROPERTIES DEPENDS integration.install)

if (CMAKE_CROSSCOMPILING)
    return()
endif()

gtest_discover_tests(vul_tests DISCOVERY_TIMEOUT 100)

=== debian/changelog ===
vulkan-utility-libraries (1.3.275.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 30 Jan 2024 14:23:26 +0200

vulkan-utility-libraries (1.3.268.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1055277)

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 07 Dec 2023 18:22:45 +0200

=== debian/control ===
Source: vulkan-utility-libraries
Priority: optional
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Uploaders: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libvulkan-dev (>= 1.3.275.0),
Standards-Version: 4.6.2
Section: libs
Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries
Vcs-Git: https://salsa.debian.org/xorg-team/vulkan/vulkan-utility-libraries.git
Vcs-Browser: https://salsa.debian.org/xorg-team/vulkan/vulkan-utility-libraries

Package: vulkan-utility-libraries-dev
Architecture: linux-any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends},
Conflicts: vulkan-validationlayers-dev (<< 1.3.268.0-1)
Breaks: vulkan-validationlayers-dev (<< 1.3.268.0-1)
Replaces: vulkan-validationlayers-dev (<< 1.3.268.0-1)
Description: Vulkan Utility Libraries -- development files
 This project provides libraries useful for other Vulkan projects.
 .
 This package includes files needed for development.

## vulkan-utility-libraries 1.3.283.0

=== debian/changelog ===
vulkan-utility-libraries (1.3.283.0-1) unstable; urgency=medium

  * New upstream release.
  * install: Updated.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 30 May 2024 11:16:55 +0300

vulkan-utility-libraries (1.3.280.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 17 Apr 2024 19:08:30 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.3.275.0),
+ libvulkan-dev (>= 1.3.283.0),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries

## vulkan-utility-libraries 1.3.290.0

=== debian/changelog ===
vulkan-utility-libraries (1.3.290.0-2) unstable; urgency=medium

  [ Pino Toscano ]
  * Enable the build on all the architectures, as this source is portable,
    and upstream accepts ports:
    - switch the architecture of the binaries from linux-any to any

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 30 Aug 2024 08:09:13 +0300

vulkan-utility-libraries (1.3.290.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 29 Aug 2024 12:11:19 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.3.283.0),
+ libvulkan-dev (>= 1.3.290.0),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries
@@ -12,7 +12,7 @@
 Vcs-Browser: https://salsa.debian.org/xorg-team/vulkan/vulkan-utility-libraries
 
 Package: vulkan-utility-libraries-dev
-Architecture: linux-any
+Architecture: any
 Section: libdevel
 Depends: ${shlibs:Depends}, ${misc:Depends},
 Conflicts: vulkan-validationlayers-dev (<< 1.3.268.0-1)

## vulkan-utility-libraries 1.3.296.0

=== debian/changelog ===
vulkan-utility-libraries (1.3.296.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 16 Oct 2024 13:53:44 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.3.290.0),
+ libvulkan-dev (>= 1.3.296.0),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries

## vulkan-utility-libraries 1.4.304.0

=== debian/changelog ===
vulkan-utility-libraries (1.4.304.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 16 Jan 2025 16:46:38 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.3.296.0),
+ libvulkan-dev (>= 1.4.304.0),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries

=== debian/rules ===
#!/usr/bin/make -f

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --builddirectory=build/

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp

## vulkan-utility-libraries 1.4.309.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,11 +3,9 @@
 # Copyright 2023 LunarG, Inc.
 #
 # SPDX-License-Identifier: Apache-2.0
-cmake_minimum_required(VERSION 3.17.2)
+cmake_minimum_required(VERSION 3.22.1)
 
 project(VUL LANGUAGES CXX)
-
-string(COMPARE EQUAL ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_SOURCE_DIR} VUL_IS_TOP_LEVEL) # Remove when min is 3.21
 
 set_property(GLOBAL PROPERTY USE_FOLDERS ON) # Remove when min is 3.26, see CMP0143
 
@@ -30,27 +28,33 @@
 add_subdirectory(src)
 add_subdirectory(include)
 
-if (VUL_IS_TOP_LEVEL)
+if (PROJECT_IS_TOP_LEVEL)
     option(BUILD_TESTS "Build tests")
     if (BUILD_TESTS)
         enable_testing()
         add_subdirectory(tests)
     endif()
+endif()
+
+option(VUL_ENABLE_INSTALL "Enable install" ${PROJECT_IS_TOP_LEVEL})
+
+if (VUL_ENABLE_INSTALL)
 
     include(GNUInstallDirs)
     include(CMakePackageConfigHelpers)
 
     install(
-        DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include/${API_TYPE}/"
+        DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/include/vulkan/"
         DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/vulkan"
     )
 
     # Create VulkanUtilityLibraries-targets.cmake
     set_target_properties(VulkanLayerSettings PROPERTIES EXPORT_NAME "LayerSettings")
     set_target_properties(VulkanUtilityHeaders PROPERTIES EXPORT_NAME "UtilityHeaders")
+    set_target_properties(VulkanSafeStruct PROPERTIES EXPORT_NAME "SafeStruct")
     set_target_properties(VulkanCompilerConfiguration PROPERTIES EXPORT_NAME "CompilerConfiguration")
     install(
-        TARGETS VulkanLayerSettings VulkanUtilityHeaders VulkanCompilerConfiguration
+        TARGETS VulkanLayerSettings VulkanUtilityHeaders VulkanSafeStruct VulkanCompilerConfiguration
         EXPORT VulkanUtilityLibraries-targets
         INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
     )

=== debian/changelog ===
vulkan-utility-libraries (1.4.309.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 18 Mar 2025 19:31:07 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.4.304.0),
+ libvulkan-dev (>= 1.4.309.0),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries

## vulkan-utility-libraries 1.4.321.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,22 @@
 
 find_package(VulkanHeaders CONFIG)
 
+option(VUL_ENABLE_ASAN "Use address sanitization")
+if (VUL_ENABLE_ASAN)
+    add_compile_options(-fsanitize=address)
+    if (NOT MSVC)
+        add_link_options(-fsanitize=address)
+    endif()
+endif()
+
+option(VUL_ENABLE_UBSAN "Use undefined behavior sanitization")
+if (VUL_ENABLE_UBSAN)
+    if (NOT MSVC)
+        add_compile_options(-fsanitize=undefined)
+        add_link_options(-fsanitize=undefined)
+    endif()
+endif()
+
 add_subdirectory(src)
 add_subdirectory(include)
 
@@ -37,7 +53,6 @@
 endif()
 
 option(VUL_ENABLE_INSTALL "Enable install" ${PROJECT_IS_TOP_LEVEL})
-
 if (VUL_ENABLE_INSTALL)
 
     include(GNUInstallDirs)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,7 @@
     target_compile_options(VulkanCompilerConfiguration INTERFACE
         /W4
         /we5038 # Enable warning about MIL ordering in constructors
+	/wd4324 # Disable warning about alignment padding
     )
 
     # Enforce stricter ISO C++
@@ -90,4 +91,7 @@
     endif()
 endif()
 
+option(VUL_MOCK_ANDROID "Enable building for Android on desktop for testing with MockICD setup")
+
 add_subdirectory(layer)
+add_subdirectory(vulkan)

=== src/vulkan/CMakeLists.txt ===
# Copyright 2023 The Khronos Group Inc.
# Copyright 2023 Valve Corporation
# Copyright 2023 LunarG, Inc.
#
# SPDX-License-Identifier: Apache-2.0
set(CMAKE_FOLDER "${CMAKE_FOLDER}/VulkanSafeStruct")

add_library(VulkanSafeStruct STATIC)
add_library(Vulkan::SafeStruct ALIAS VulkanSafeStruct)

target_sources(VulkanSafeStruct PRIVATE
    vk_safe_struct_core.cpp
    vk_safe_struct_ext.cpp
    vk_safe_struct_khr.cpp
    vk_safe_struct_utils.cpp
    vk_safe_struct_vendor.cpp
    vk_safe_struct_manual.cpp
)

target_link_Libraries(VulkanSafeStruct
   PUBLIC
      Vulkan::Headers
      Vulkan::UtilityHeaders
   PRIVATE
      Vulkan::CompilerConfiguration
)

if(VUL_MOCK_ANDROID)
	target_compile_definitions(VulkanSafeStruct PUBLIC VK_USE_PLATFORM_ANDROID_KHR VUL_MOCK_ANDROID)
endif()

=== tests/integration/CMakeLists.txt ===
# Copyright 2023 The Khronos Group Inc.
# Copyright 2023 Valve Corporation
# Copyright 2023 LunarG, Inc.
#
# SPDX-License-Identifier: Apache-2.0
cmake_minimum_required(VERSION 3.17)

project(INTEGRATION LANGUAGES C)

add_library(foobar STATIC)

target_compile_features(foobar PRIVATE c_std_99)

target_sources(foobar PRIVATE
    vk_dispatch_table.c
    vk_enum_string_helper.c
    vk_layer_settings.c
    vk_format_utils.c
    vk_format_utils_2.c # Need two translation units to test if header file behaves correctly.
)

if (FIND_PACKAGE_TESTING)
    find_package(VulkanUtilityLibraries REQUIRED CONFIG)
else()
    add_subdirectory(${PROJECT_SOURCE_DIR}/../../ ${PROJECT_BINARY_DIR}/vul)
endif()

# The intent is ensuring we don't accidentally change the names of these
# targets. Since it would break downstream users.
if (NOT TARGET Vulkan::LayerSettings)
    message(FATAL_ERROR "Vulkan::LayerSettings target not defined!")
endif()

if (NOT TARGET Vulkan::UtilityHeaders)
    message(FATAL_ERROR "Vulkan::UtilityHeaders target not defined!")
endif()

target_link_libraries(foobar PRIVATE
    Vulkan::LayerSettings
    Vulkan::UtilityHeaders
)

get_filename_component(VUL_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/../../include/" ABSOLUTE)

# Get all the header files we SHIP
file(GLOB_RECURSE public_headers
    CONFIGURE_DEPENDS
    "${VUL_INCLUDE_DIR}/*.h" "${VUL_INCLUDE_DIR}/*.hpp"
)

# Ensure each file has the same `vk_` prefix naming convention.
foreach(header IN LISTS public_headers)
    get_filename_component(header ${header} "NAME")
    message(DEBUG "Checking ${header}")
    if (${header} MATCHES "^vk_")
        message(DEBUG "Correct naming convention!")
    else()
        # EX: "Invalid file name! vk_dispatch_table.h"
        message(FATAL_ERROR "Invalid file name! ${header}")
    endif()
endforeach()

# Ensure gn stub file contains all public headers.
# Otherwise we can break the GN build by accident.
get_filename_component(gn_stub_file "${CMAKE_CURRENT_SOURCE_DIR}/../../scripts/gn/stub.cpp" ABSOLUTE)
if (NOT EXISTS ${gn_stub_file})
    message(FATAL_ERROR "Couldn't find gn stub file!")
endif()

file(READ ${gn_stub_file} gn_stub_contents)

foreach(header IN LISTS public_headers)
    get_filename_component(header ${header} "NAME")
    if (gn_stub_contents MATCHES "${header}>")
        message(DEBUG "Stub contains ${header}")
    else()
        message(FATAL_ERROR "Update ${gn_stub_file} with ${header}!")
    endif()
endforeach()

# NOTE: Because Vulkan::Headers header files are exposed in the public facing interface
# we must expose this library to users.
get_target_property(property Vulkan::LayerSettings INTERFACE_LINK_LIBRARIES)
if (NOT property MATCHES "Vulkan::Headers")
    message(FATAL_ERROR "Vulkan::Headers not linked properly!")
endif()
get_target_property(property Vulkan::UtilityHeaders INTERFACE_LINK_LIBRARIES)
if (NOT property MATCHES "Vulkan::Headers")
    message(FATAL_ERROR "Vulkan::Headers not linked properly!")
endif()

# Prevent regression of https://github.com/KhronosGroup/Vulkan-Utility-Libraries/issues/103
get_target_property(property Vulkan::LayerSettings INTERFACE_COMPILE_OPTIONS)
if (NOT property STREQUAL "property-NOTFOUND")
    message(FATAL_ERROR "Vulkan::LayerSettings shouldn't export compile options! ${property}")
endif()
get_target_property(property Vulkan::UtilityHeaders INTERFACE_COMPILE_OPTIONS)
if (NOT property STREQUAL "property-NOTFOUND")
    message(FATAL_ERROR "Vulkan::UtilityHeaders shouldn't export compile options! ${property}")
endif()

=== debian/changelog ===
vulkan-utility-libraries (1.4.321.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 11 Aug 2025 06:30:57 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.4.309.0),
+ libvulkan-dev (>= 1.4.321.0),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries

=== debian/watch ===
version=4
opts="repack,filenamemangle=s/(?:.*?)?sdk[_-]?(\d[\d.]*)\.tar\.gz/vulkan-utility-libraries-$1.tar.gz/" \
 https://github.com/KhronosGroup/Vulkan-Utility-Libraries/tags (?:.*?/)vulkan-sdk[_-](\d[\d.]*)\.tar\.gz

## vulkan-utility-libraries 1.4.328.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,8 @@
 # SPDX-License-Identifier: Apache-2.0
 cmake_minimum_required(VERSION 3.22.1)
 
-project(VUL LANGUAGES CXX)
+# The VERSION field is generated with the "--generated-version" flag in the generate_source.py script
+project(VUL VERSION 1.4.327 LANGUAGES CXX)
 
 set_property(GLOBAL PROPERTY USE_FOLDERS ON) # Remove when min is 3.26, see CMP0143
 
@@ -23,7 +24,7 @@
 
 add_subdirectory(scripts)
 
-find_package(VulkanHeaders CONFIG)
+find_package(VulkanHeaders ${CMAKE_PROJECT_VERSION} CONFIG)
 
 option(VUL_ENABLE_ASAN "Use address sanitization")
 if (VUL_ENABLE_ASAN)

=== scripts/CMakeLists.txt ===
# ~~~
# Copyright (c) 2023 LunarG, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ~~~

option(UPDATE_DEPS "Run update_deps.py for user")
if (UPDATE_DEPS)
    find_package(Python3 REQUIRED QUIET)

    set(update_dep_py "${CMAKE_CURRENT_LIST_DIR}/update_deps.py")
    set(known_good_json "${CMAKE_CURRENT_LIST_DIR}/known_good.json")

    set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS ${update_dep_py} ${known_good_json})

    list(APPEND update_dep_command "${update_dep_py}")
    list(APPEND update_dep_command "--generator")
    list(APPEND update_dep_command "${CMAKE_GENERATOR}")

    if (CMAKE_GENERATOR_PLATFORM)
        list(APPEND update_dep_command "--arch")
        list(APPEND update_dep_command "${CMAKE_GENERATOR_PLATFORM}")
    endif()

    if (NOT CMAKE_BUILD_TYPE)
        message(WARNING "CMAKE_BUILD_TYPE not set. Using Debug for dependency build type")
        set(_build_type Debug)
    else()
        set(_build_type ${CMAKE_BUILD_TYPE})
    endif()
    list(APPEND update_dep_command "--config")
    list(APPEND update_dep_command "${_build_type}")
    list(APPEND update_dep_command "--api")
    list(APPEND update_dep_command "${API_TYPE}")

    set(UPDATE_DEPS_DIR_SUFFIX "${_build_type}")
    if (CMAKE_CROSSCOMPILING)
        set(UPDATE_DEPS_DIR_SUFFIX "${CMAKE_SYSTEM_NAME}/${UPDATE_DEPS_DIR_SUFFIX}/${CMAKE_SYSTEM_PROCESSOR}")
    else()
        math(EXPR bitness "8 * ${CMAKE_SIZEOF_VOID_P}")
        set(UPDATE_DEPS_DIR_SUFFIX "${UPDATE_DEPS_DIR_SUFFIX}/${bitness}")
    endif()    
    set(UPDATE_DEPS_DIR "${PROJECT_SOURCE_DIR}/external/${UPDATE_DEPS_DIR_SUFFIX}" CACHE PATH "Location where update_deps.py installs packages")
    list(APPEND update_dep_command "--dir" )
    list(APPEND update_dep_command "${UPDATE_DEPS_DIR}")

    if (NOT BUILD_TESTS)
        list(APPEND update_dep_command "--optional=tests")
    endif()

    if (UPDATE_DEPS_SKIP_EXISTING_INSTALL)
        list(APPEND update_dep_command "--skip-existing-install")
    endif()

    list(APPEND cmake_vars "CMAKE_TOOLCHAIN_FILE")

    # Avoids manually setting CMAKE_SYSTEM_NAME unless it's needed:
    # https://cmake.org/cmake/help/latest/variable/CMAKE_CROSSCOMPILING.html
    if (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "${CMAKE_HOST_SYSTEM_NAME}")
        list(APPEND cmake_vars "CMAKE_SYSTEM_NAME")
    endif()
    if (APPLE)
        list(APPEND cmake_vars "CMAKE_OSX_ARCHITECTURES" "CMAKE_OSX_DEPLOYMENT_TARGET")
    endif()
    if (NOT MSVC_IDE)
        list(APPEND cmake_vars "CMAKE_CXX_COMPILER" "CMAKE_C_COMPILER" "CMAKE_ASM_COMPILER")
    endif()
    if (ANDROID)
        list(APPEND cmake_vars "ANDROID_PLATFORM" "CMAKE_ANDROID_ARCH_ABI" "CMAKE_ANDROID_STL_TYPE" "CMAKE_ANDROID_RTTI" "CMAKE_ANDROID_EXCEPTIONS" "ANDROID_USE_LEGACY_TOOLCHAIN_FILE")
    endif()

    set(cmake_var)
    foreach(var IN LISTS cmake_vars)
        if (DEFINED ${var})
            list(APPEND update_dep_command "--cmake_var")
            list(APPEND update_dep_command "${var}=${${var}}")
        endif()
    endforeach()

    if (cmake_var)
        list(APPEND update_dep_command "${cmake_var}")
    endif()

    file(TIMESTAMP ${update_dep_py} timestamp_1)
    file(TIMESTAMP ${known_good_json} timestamp_2)

    string("MD5" md5_hash "${timestamp_1}-${timestamp_2}-${update_dep_command}")

    set(UPDATE_DEPS_HASH "0" CACHE STRING "Default value until we run update_deps.py")
    mark_as_advanced(UPDATE_DEPS_HASH)

    if ("${UPDATE_DEPS_HASH}" STREQUAL "0")
        list(APPEND update_dep_command "--clean-build")
        list(APPEND update_dep_command "--clean-install")
    endif()

    if ("${md5_hash}" STREQUAL $CACHE{UPDATE_DEPS_HASH})
        message(DEBUG "update_deps.py: no work to do.")
    else()
        execute_process(
            COMMAND ${Python3_EXECUTABLE} ${update_dep_command}
            RESULT_VARIABLE _update_deps_result
        )
        if (NOT (${_update_deps_result} EQUAL 0))
            message(FATAL_ERROR "Could not run update_deps.py which is necessary to download dependencies.")
        endif()
        set(UPDATE_DEPS_HASH ${md5_hash} CACHE STRING "Ensure we only run update_deps.py when we need to." FORCE)
        include("${UPDATE_DEPS_DIR}/helper.cmake")
    endif()
endif()
if (VULKAN_HEADERS_INSTALL_DIR)
    list(APPEND CMAKE_PREFIX_PATH ${VULKAN_HEADERS_INSTALL_DIR})
    set(CMAKE_REQUIRE_FIND_PACKAGE_VulkanHeaders TRUE PARENT_SCOPE)
endif()
if (GOOGLETEST_INSTALL_DIR)
    list(APPEND CMAKE_PREFIX_PATH ${GOOGLETEST_INSTALL_DIR})
endif()
if (MAGIC_ENUM_INSTALL_DIR)
    list(APPEND CMAKE_PREFIX_PATH ${MAGIC_ENUM_INSTALL_DIR})
endif()

if (CMAKE_CROSSCOMPILING)
    set(CMAKE_FIND_ROOT_PATH ${CMAKE_FIND_ROOT_PATH} ${CMAKE_PREFIX_PATH} PARENT_SCOPE)
else()
    set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} PARENT_SCOPE)
endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-# Copyright 2023 The Khronos Group Inc.
-# Copyright 2023 Valve Corporation
-# Copyright 2023 LunarG, Inc.
+# Copyright 2023-2024 The Khronos Group Inc.
+# Copyright 2023-2024 Valve Corporation
+# Copyright 2023-2024 LunarG, Inc.
 #
 # SPDX-License-Identifier: Apache-2.0
 
@@ -16,6 +16,9 @@
 )
 
 target_sources(vul_tests PRIVATE
+    safe_struct.cpp
+    small_containers.cpp
+    sparse_range_map.cpp
     struct_helper.cpp
     test_formats.cpp
     test_interface.cpp
@@ -35,6 +38,7 @@
     Vulkan::UtilityHeaders
     Vulkan::LayerSettings
     Vulkan::CompilerConfiguration
+    Vulkan::SafeStruct
 )
 
 # Test add_subdirectory suppport

=== debian/changelog ===
vulkan-utility-libraries (1.4.328.1-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Mon, 10 Nov 2025 13:20:15 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.4.321.0),
+ libvulkan-dev (>= 1.4.328.1),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries

## vulkan-utility-libraries 1.4.335.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 cmake_minimum_required(VERSION 3.22.1)
 
 # The VERSION field is generated with the "--generated-version" flag in the generate_source.py script
-project(VUL VERSION 1.4.327 LANGUAGES CXX)
+project(VUL VERSION 1.4.335 LANGUAGES CXX)
 
 set_property(GLOBAL PROPERTY USE_FOLDERS ON) # Remove when min is 3.26, see CMP0143
 
@@ -24,7 +24,7 @@
 
 add_subdirectory(scripts)
 
-find_package(VulkanHeaders ${CMAKE_PROJECT_VERSION} CONFIG)
+find_package(VulkanHeaders ${PROJECT_VERSION} CONFIG)
 
 option(VUL_ENABLE_ASAN "Use address sanitization")
 if (VUL_ENABLE_ASAN)
@@ -85,7 +85,7 @@
     file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/VulkanUtilityLibrariesConfig.cmake.in" [=[
         include(CMakeFindDependencyMacro)
         # NOTE: Because VulkanHeaders is a PUBLIC dependency it needs to be found prior to VulkanUtilityLibraries
-        find_dependency(VulkanHeaders REQUIRED)
+        find_dependency(VulkanHeaders @PROJECT_VERSION@ REQUIRED)
 
         @PACKAGE_INIT@
 
@@ -105,3 +105,13 @@
         DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/VulkanUtilityLibraries
     )
 endif()
+
+option(VUL_CODEGEN "Enable Vulkan-Utility-Libraries code generation")
+if(VUL_CODEGEN)
+    find_package(Python3 REQUIRED)
+    add_custom_target(vul_codegen
+        COMMAND Python3::Interpreter ${PROJECT_SOURCE_DIR}/scripts/generate_source.py
+            "${VULKAN_HEADERS_INSTALL_DIR}/${CMAKE_INSTALL_DATADIR}/vulkan/registry"
+            --generated-version ${VulkanHeaders_VERSION} --api ${API_TYPE}
+    )
+endif()

=== debian/changelog ===
vulkan-utility-libraries (1.4.335.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 18 Dec 2025 13:08:03 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.4.328.1),
+ libvulkan-dev (>= 1.4.335.0),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries

## vulkan-utility-libraries 1.4.341.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 cmake_minimum_required(VERSION 3.22.1)
 
 # The VERSION field is generated with the "--generated-version" flag in the generate_source.py script
-project(VUL VERSION 1.4.335 LANGUAGES CXX)
+project(VUL VERSION 1.4.341 LANGUAGES CXX)
 
 set_property(GLOBAL PROPERTY USE_FOLDERS ON) # Remove when min is 3.26, see CMP0143

=== debian/changelog ===
vulkan-utility-libraries (1.4.341.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libvulkan-dev build-dep.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 06 Feb 2026 11:29:59 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Uploaders: Timo Aaltonen <tjaalton@debian.org>
 Build-Depends: debhelper-compat (= 13),
  cmake,
- libvulkan-dev (>= 1.4.335.0),
+ libvulkan-dev (>= 1.4.341.0),
 Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/KhronosGroup/Vulkan-Utility-Libraries
